// gcc -m32 -static  -L/usr/lib/gcc-cross/i686-linux-gnu/8/ -c runtime.c -o runtime.o
// as --32 hello32.s -o hello32.o
// ld -m elf_i386 -L. -e main runtime.o hello32.o -lc
#include <stdio.h>
#include <stdlib.h>

int printInt(int a) {
	printf("%d\n", a);
}

int printStr(const char *c) {
	printf("%s\n", c);
}

char * readStr() {
	char *line = NULL;
	size_t len = 0;
	getline(&line, &len, stdin);
	return line;
}

int readInt () {
	char minus = 0;
	int result = 0;
	char ch;
	ch = getchar();
	while (1) {
		if (ch == '-') break;
		if (ch >= '0' && ch <= '9') break;
		ch = getchar();
	}
	if (ch == '-') minus = 1; else result = ch-'0';
	while (1) {
		ch = getchar();
		if (ch < '0' || ch > '9') break;
		result = result*10 + (ch - '0');
	}
	if (minus)
		return -result;
	else
		return result;
}

void error() {
	puts("runtime error");
	exit(1);
}

char* __latte_mem_init(size_t size, void* virtTab) {
	char *buf = calloc(len, size);
	if (!buf) error();
	*((void**)buf) = virtTab;
	return buf;
}
char* __latte_mem_init_array(int len, size_t size, void* virtTab) {
	if (len < 0) error();
	char *buf = calloc(len, size);
	if (!buf) error();
	if (virtTab) {
		for (size_t i = 0; i < len; i++) {
			*((void**)(buf + i * size)) = virtTab;
		}
	}
	return buf;
}
